class Plugin

# class Plugin | A plugin is the way to add actions to an existing KParts application, or to a Part. More...
Full name | `KParts::Plugin`
Definition | `#include <plugin.h>`
Inherits | KXMLGUIClient (kdeui) [virtual public ], QObject (qt) [public ]
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Types

- struct PluginInfo

#### Public Methods

- Plugin ( QObject* parent = 0, const char* name = 0 )
- virtual ~Plugin ()
- virtual QString xmlFile () const
- virtual QString localXMLFile () const

#### Public Static Methods

- static void loadPlugins ( QObject *parent, const KInstance * instance )
- static void loadPlugins ( QObject *parent, const QValueList &pluginInfos )
- static void loadPlugins ( QObject *parent, const QValueList &pluginInfos, const KInstance * instance )
- static void loadPlugins ( QObject *parent, KXMLGUIClient* parentGUIClient, KInstance* instance, bool enableNewPluginsByDefault = true )
- static QPtrList pluginObjects ( QObject *parent )

#### Protected Methods

- virtual void setInstance ( KInstance *instance )

#### Protected Static Methods

- static QValueList pluginInfos ( const KInstance * instance )
- static Plugin* loadPlugin ( QObject * parent, const char* libname )

## Detailed Description

A plugin is the way to add actions to an existing KParts application, or to a Part.

The XML of those plugins looks exactly like of the shell or parts, with one small difference: The document tag should have an additional attribute, named "library", and contain the name of the library implementing the plugin.

If you want this plugin to be used by a part, you need to install the rc file under the directory "data" (KDEDIR/share/apps usually)+"/instancename/kpartplugins/" where instancename is the name of the part's instance.

PluginInfo (struct) | ### PluginInfo

Plugin ( QObject* parent = 0, const char* name = 0 ) | ### Plugin

Construct a new KParts plugin.

~Plugin () | ### ~Plugin

[virtual]

Destructor.

QString xmlFile () | ### xmlFile

[const virtual]

Reimplemented for internal reasons

Reimplemented from KXMLGUIClient.

QString localXMLFile () | ### localXMLFile

[const virtual]

Reimplemented for internal reasons

Reimplemented from KXMLGUIClient.

void loadPlugins ( QObject *parent, const KInstance * instance ) | ### loadPlugins

[static]

Load the plugin libraries from the directories appropriate to `instance` and make the Plugin objects children of `parent`.

It is recommended to use the last loadPlugins method instead, to support enabling and disabling of plugins.

void loadPlugins ( QObject *parent, const QValueList &pluginInfos ) | ### loadPlugins

[static]

Load the plugin libraries specified by the list `docs` and make the Plugin objects children of `parent` .

It is recommended to use the last loadPlugins method instead, to support enabling and disabling of plugins.

void loadPlugins ( QObject *parent, const QValueList &pluginInfos, const KInstance * instance ) | ### loadPlugins

[static]

Load the plugin libraries specified by the list `pluginInfos`, make the Plugin objects children of `parent`, and use the given `instance`.

It is recommended to use the last loadPlugins method instead, to support enabling and disabling of plugins.

void loadPlugins ( QObject *parent, KXMLGUIClient* parentGUIClient, KInstance* instance, bool enableNewPluginsByDefault = true ) | ### loadPlugins

[static]

Load the plugin libraries for the given `instance`, make the Plugin objects children of `parent`, and insert the plugin as a child GUI client of `parentGUIClient`.

This method uses the KConfig object of the given instance, to find out which plugins are enabled and which are disabled. What happens by default (i.e. for new plugins that are not in that config file) is controlled by `enableNewPluginsByDefault`.

If a disabled plugin is already loaded it will be removed from the GUI factory and deleted.

This method is automatically called by KParts::Plugin and by KParts::MainWindow.

QPtrList pluginObjects ( QObject *parent ) | ### pluginObjects

[static]

Returns a list of plugin objects loaded for `parent`. This functions basically calls the queryList method of QObject to retrieve the list of child objects inheriting KParts::Plugin .

QValueList pluginInfos ( const KInstance * instance ) | ### pluginInfos

[protected static]

Look for plugins in the `instance`'s "data" directory (+"/kpartplugins")

Returns: A list of QDomDocument s, containing the parsed xml documents returned by plugins.

Plugin* loadPlugin ( QObject * parent, const char* libname ) | ### loadPlugin

[protected static]

Returns: The plugin created from the library `libname`

void setInstance ( KInstance *instance ) | ### setInstance

[protected virtual]

Reimplemented from KXMLGUIClient.

Generated by: root on macppc.ports.openbsd.org on Sat Sep 6 10:37:24 2003, using kdoc 2.0a54.